//
// Sep98.cpp
//
// This program illustrates an oddity with Visual C++ 5.0. 
// In this program, we initialize a constant int with a
// floating point value.  In main() I assign the resulting 
// integral value to an integer, then attempt to print
// the integer.  But instead of printing the expected value 
// of 75, the compiler prints a value of  27516292!
//
// Initializing a constant int with a floating point value 
// might not seem like a smart thing to do, but it does
// appear to be legal.  The CD2 draft standard seems to 
// say that an initializer can be used as long as there 
// is a standard conversion that can be used to convert
// to the type of the object being initialized.  Of course, 
// there is standard conversion from floating point to
// integral types.
//
//  Compile this program with Visual C++ 5.0 SP3 using the 
//  following command line:
//
//     cl /GX Sep98.cpp
//
     
#include <stdio.h>
     

static const int ConstVal = 75.0;
// this also fails-->    const int ConstVal = 75.0;
// this would work-->    int ConstVal = 75.0;


int main()
{
    int i = ConstVal;

    printf("i = %d\n", i);
    return 1;
}
     

