#ifndef  _WINMAIN_H_
#define  _WINMAIN_H_
#include <windows.h>

// =================================================================
// COMMAND LINE STRUCTURE
// =================================================================

typedef struct _CMDLINE
    {
    DWORD   argc;
    DWORD   envc;
    PTBYTE *argv;
    PTBYTE *envp;
    PTBYTE  cmdp;
    }
    CMDLINE, *PCMDLINE;
#define CMDLINE_ sizeof (CMDLINE)

// =================================================================
// WINMAIN PROTOTYPE
// =================================================================

#pragma warning (disable: 4028)

int WINAPI WinMain (HINSTANCE hInstance,
                    PCMDLINE  pcl,
                    PTBYTE    ptCmdLine,
                    int       iShowCmd);

#pragma warning (default: 4028)

// =================================================================
// STARTUP CODE
// =================================================================

#pragma comment (linker, "/entry:\"WinStartup\"")

// -----------------------------------------------------------------

void WinStartup (void)
    {
    STARTUPINFO si;
    CMDLINE     cl;
    PVOID       pBuffer;
    PTBYTE      ptCmdLine;
    PTBYTE      ptEnvStrings;
    TBYTE       q;
    int         iShowCmd;
    DWORD       i;
    DWORD       dStatus = 0;

    ptCmdLine    = GetCommandLine ();
    ptEnvStrings = GetEnvironmentStrings ();

    cl.argc = i = 0;
    while (TRUE)
        {
        while (ptCmdLine [i++] == ' ');
        q = (ptCmdLine [--i] == '"' ? ptCmdLine [i++] : ' ');
        if (!ptCmdLine [i]) break;

        cl.argc++;
        while (ptCmdLine [i] && (ptCmdLine [i++] != q));
        }
    cl.envc = i = 0;
    while (ptEnvStrings [i])
        {
        if (ptEnvStrings [i] != '=') cl.envc++;
        while (ptEnvStrings [i++]);
        }
    pBuffer =
        LocalAlloc (LMEM_FIXED,
                    ((cl.argc                ) * sizeof (PTBYTE)) +
                    ((cl.envc             + 1) * sizeof (PTBYTE)) +
                    ((lstrlen (ptCmdLine) + 1) * sizeof ( TBYTE)));

    if (pBuffer != NULL)
        {
        cl.argv = (PTBYTE *) pBuffer;
        cl.envp = cl.argv + cl.argc;
        cl.cmdp = (PTBYTE) (cl.envp + (cl.envc + 1));

        lstrcpy (cl.cmdp, ptCmdLine);

        cl.argc = i = 0;
        while (TRUE)
            {
            while (cl.cmdp [i++] == ' ');
            q = (cl.cmdp [--i] == '"' ? cl.cmdp [i++] : ' ');
            if (!cl.cmdp [i]) break;

            cl.argv [cl.argc++] = cl.cmdp + i;
            while (cl.cmdp [i])
                {
                if (cl.cmdp [i++] == q)
                    {
                    cl.cmdp [i-1] = 0;
                    break;
                    }
                }
            }
        cl.envc = i = 0;
        while (ptEnvStrings [i])
            {
            if (ptEnvStrings [i] != '=')
                {
                cl.envp [cl.envc++] = ptEnvStrings + i;
                }
            while (ptEnvStrings [i++]);
            }
        cl.envp [cl.envc] = NULL;

        while (*ptCmdLine++ == ' ');
        q = (*--ptCmdLine == '"' ? *ptCmdLine++ : ' ');
        while (*ptCmdLine && (*ptCmdLine++ != q));
        while (*ptCmdLine++ == ' ');
        ptCmdLine--;

        GetStartupInfo (&si);

        iShowCmd = (si.dwFlags & STARTF_USESHOWWINDOW
                    ? (int) si.wShowWindow
                    : SW_SHOWDEFAULT);

        dStatus = WinMain (GetModuleHandle (NULL),
                           &cl,
                           ptCmdLine,
                           iShowCmd);
        }
    ExitProcess (dStatus);
    return;
    }

// -----------------------------------------------------------------

#endif // #ifndef _WINMAIN_H_

